<?
  function connect_db()
  {
    $dsn  = $GLOBALS['cfg']['db']['name'] . "://";
    $dsn .= $GLOBALS['cfg']['db']['user'] . ":";
    $dsn .= $GLOBALS['cfg']['db']['pass'] . "@";
    $dsn .= $GLOBALS['cfg']['db']['host'];
    if(strlen($GLOBALS['cfg']['db']['port']) != 0)
      $dsn .= ":" . $GLOBALS['cfg']['db']['port'];
    $dsn .= "/" . $GLOBALS['cfg']['db']['db'];
    if($GLOBALS['cfg']['db']['persist'] == true)
      $dsn .= "?persist";

    $db = NewADOConnection($dsn);
    if(!$db)
    {
      $mess = "Error connection to " . $GLOBALS['cfg']['db']['name'] . "... exit...";
      write_log($mess);
      die ($mess . "\n");
    }
    $db->debug = $GLOBALS['cfg']['db']['debug'];

    return $db;
  }

  function check_file($f, $file_name, $mess, $write_to_log, $die)
  {
    if($f == false)
    {
      $ret = 0;
      if($write_to_log == 1)
      {
        $mess .= " failed: " . $file_name . "...";
        if($die == 1)
        {
          $mess .= "\nExit...";
          echo $mess . "\n";
          write_log($mess);
          die;
        } else
        {
          write_log($mess);
        }
      }
    } else
    {
      $ret = 1;
    }

    return $ret;
  }

  function write_log($str)
  {
    $cur_date = date("Y-m-d H:i:s");
    $filename = $GLOBALS['cfg']['db']['sql_err'];
    $f = fopen($filename, "a");
    check_file($f, $filename, "fopen (a)", 0, 1);

    $res = fwrite($f, $cur_date . "\n" . $str . "\n\n");
    check_file($res, $filename, "write", 0, 1);
  }

  function check_sql_result($res, $sql, $die)
  {
    if($res === false)
    {
      $ret = 0;
      echo "sql error";

      if($die == 1)
      {
        echo " - die...\n";
        write_log($sql . "\ndie...");
        die;
      } else
      {
        echo " - continue...\n";
        write_log($sql);
      }
    } else
    {
      $ret = 1;
    }

    $GLOBALS['var']['sql_count']++;

    return $ret;
  }

  function unknown_user()
  {
    $ret = "";

    $ret[0] = 0;                      //user_id
    $ret[1] = 0;                      //group_id
    $ret[2] = "Unknown";              //fio
    $ret[3] = 0;                      //max
    $ret[4] = 0;                      //status
    $ret[5] = "2000-01-01 00:00:00";  //reg_datetime
    $ret[6] = 0;                      //tarif_id
    $ret[7] = "";                     //pass
    $ret[8] = "2000-01-01 00:00:00";  //active_start
    $ret[9] = "2000-01-01 00:00:00";  //active_finish

    return $ret;
  }

  function find_user_period($db_con, $tarif_id, $time)
  {
    $ret = "";

    $SQL = "SELECT period_id, coef, comment FROM tarif_period WHERE tarif_id=\"" . $tarif_id . "\" AND start<=\"" . $time . "\" AND finish>=\"" . $time . "\"";
    $sql_res = $db_con->Execute($SQL);
    check_sql_result($sql_res, $SQL, 1);
    $rows = $sql_res->GetRows();
    if($sql_res->RecordCount() == 1)
    {
      $ret[0] = $rows[0][0]; //period_id
      $ret[1] = $rows[0][1]; //coef
      $ret[2] = $rows[0][2]; //comment
    } else
    {
      $ret[0] = 0;
      $ret[1] = 1;
      $ret[2] = "Unknown";
      write_log("Unknown tarif_period. $tarif_id=" . $tarif_id . ", time=" . $time);
    }

    return $ret;
  }

  function find_admin($db_con, $user_id)
  {
    $SQL = "SELECT group_id, admin_level, status FROM admin_group WHERE user_id=\"" . $user_id . "\" ORDER BY group_id";
    $sql_res = $db_con->GetAll($SQL);
    check_sql_result($sql_res, $SQL, 1);

    return $sql_res;
  }

  function admin_group($db_con, $admin_id, $group_id)
  {
    $SQL = "SELECT group_id, admin_level, status FROM admin_group WHERE user_id=\"" . $admin_id . "\" AND (group_id=\"" . $group_id . "\" OR group_id=\"0\") AND status<>0 ORDER BY group_id";
    $sql_res = $db_con->GetAll($SQL);
    check_sql_result($sql_res, $SQL, 1);

    return $sql_res;
  }

  function super_admin_arr($db_con, $admin_level, $status)
  {
    $SQL_all_groups = "SELECT DISTINCT id, \"" . $admin_level . "\" admin_level, \"" . $status . "\" status FROM groups ORDER BY id";
    $admin_arr = $db_con->GetAll($SQL_all_groups);
    check_sql_result($admin_arr, $SQL_all_groups, 1);

    return $admin_arr;
  }

  function check_admin_user_id($db_con, $admin_id, $user_id)
  {
    //,   
    $SQL = "SELECT group_id FROM users WHERE id=\"" . addslashes($user_id) . "\"";
    $sql_res = $db_con->GetAll($SQL);
    check_sql_result($sql_res, $SQL, 1);
    //end

    if( count($sql_res) == 0 ) //  
    {
      $ret = 0;
    } else
    {
      $ret = admin_group($db_con, $admin_id, $sql_res[0][0]);
    }

    return $ret;
  }

  function find_user($db_con, $user_group)
  {
    $ret = "";

    list($user, $group) = split("@", $user_group);

    // -    $group
    $SQL = "SELECT id FROM groups WHERE group_name=\"" . addslashes($group) . "\"";
    $sql_res = $db_con->SelectLimit($SQL, 1);
    check_sql_result($sql_res, $SQL, 1);
    $rows = $sql_res->GetRows();

    if($sql_res->RecordCount() == 1)
    {
      $ret[1] = $rows[0][0];
    //end

      // -    $user    group_id
      $SQL  = "SELECT id, fio, max, status, reg_datetime, tarif_id, pass, active_start, active_finish FROM users WHERE user_name=\"" . addslashes($user) . "\" AND group_id=\"" . $ret[1] . "\" AND status<>\"2\"\n";
      $SQL .= "ORDER BY reg_datetime DESC";
      $sql_res = $db_con->Execute($SQL);
      check_sql_result($sql_res, $SQL, 1);
      $rows = $sql_res->GetRows();

      if($sql_res->RecordCount() == 1)
      {
        $ret[0] = $rows[0][0];  //user_id
        $ret[2] = $rows[0][1];  //fio
        $ret[3] = $rows[0][2];  //max
        $ret[4] = $rows[0][3];  //status
        $ret[5] = $rows[0][4];  //reg_datetime
        $ret[6] = $rows[0][5];  //tarif_id
        $ret[7] = $rows[0][6];  //pass
        $ret[8] = $rows[0][7];  //active_start
        $ret[9] = $rows[0][8];  //active_finish
      }

      if($sql_res->RecordCount() == 0) //     
      {
        $ret = unknown_user();
      }

      // -   " "  (status!=2) 
      if($sql_res->RecordCount() >= 2)
      {
        write_log("Dublicate user: " . $user . ", group = " . $group);
        $ret = unknown_user();
      }
      //end
    } else
    {
      $ret = unknown_user();
    }

    return $ret;
  }

  function squid_log_2_db($db_con, $str, $cout)
  {
    $buf = preg_split("/[\s]+/", $str);

    $i = 0; $j = 0;

    //
    $str_date = date("Y-m-d", $buf[$i]);
    $out[$j] = $str_date;
    $j++;
    //end

    //
    $str_time = date("H:i:s", $buf[$i]);
    $out[$j] = $str_time;
    $j++;
    //end

    //
    list($r, $str_msec) = split("\.", $buf[$i]);
    $out[$j] = $str_msec;
    $j++;
    //end

    //  url`
    for($i = 1; $i <= 5; $i++)
    {
      $out[$j] = $buf[$i];
      $j++;
    }
    //end

    //url
    $buf1 = "";
    for($i = 6; $i <= count($buf) - 4; $i++)
      $buf1 .= $buf[$i];
    $out[$j] = $buf1;
    $j++;
    //end

    //  url`
    for($i = count($buf) - 3; $i < count($buf); $i++)
    {
      $out[$j] = $buf[$i];
      $j++;
    }
    //end

    //  : url 
    $SQL_par = "";
    for($i = 0; $i <= 8; $i++)
      $SQL_par .= "\"" . addslashes($out[$i]) . "\", ";
    //end

    // url
    $par_url = parse_url($out[8]);
    if(isset($par_url["scheme"]))
    {
      $url_scheme = $par_url["scheme"];
      $SQL_par .= "\"" . addslashes($url_scheme) . "\", ";
    } else
    {
      $url_scheme = "";
      $SQL_par .= "\"\", ";
    }

    if(isset($par_url["host"]))
    {
      $url_host = $par_url["host"];
      $SQL_par .= "\"" . addslashes($url_host) . "\", ";
    } else
    {
      $url_host = "";
      $SQL_par .= "\"\", ";
    }

/*    if(isset($par_url["user"]))
      $SQL_par .= "\"" . addslashes($par_url["user"]) . "\", ";else
      $SQL_par .= "\"\", ";

    if(isset($par_url["pass"]))
      $SQL_par .= "\"" . addslashes($par_url["pass"]) . "\", ";else
      $SQL_par .= "\"\", ";

    if(isset($par_url["path"]))
      $SQL_par .= "\"". addslashes($par_url["path"]) . "\", ";else
      $SQL_par .= "\"\", ";

    if(isset($par_url["query"]))
      $SQL_par .= "\"" . addslashes($par_url["query"]) . "\", ";else
      $SQL_par .= "\"\", ";

    if(isset($par_url["fragment"]))
      $SQL_par .= "\"" . addslashes($par_url["fragment"]) . "\", ";else
      $SQL_par .= "\"\", ";
    //end*/

    //  
    for($i = 9; $i < count($out); $i++)
    {
      $SQL_par .= "\"" . addslashes($out[$i]) . "\"";
      if($i != count($out)-1)
        $SQL_par .= ", ";
    }
    //end

    //  
    $SQL = "INSERT INTO access_log VALUES (" . $SQL_par . ")";
    $result = $db_con->Execute($SQL);
    check_sql_result($result, $SQL, 1);
    //end

    // $out[x] :
    // 0 - 
    // 1 - 
    // 2 - .
    // 4 - IP
    // 5 - 
    // 6 - 
    // 8 - url
    // 9 - /

    //    
    if( ! (strstr($out[5], "TCP_DENIED")) )
    {
      $user_arr = find_user($db_con, $out[9]);

      //    
      if( ($user_arr[0] == 0) || ($user_arr[1] == 0) ) //  
      {
        $user_per = 0;
      } else
      {
        $period_arr = find_user_period($db_con, $user_arr[6], $str_time);
        $user_per = $period_arr[0];
      }
      //end

      //     days         
      $SQL = "SELECT count(*) FROM days WHERE date=\"" . $str_date . "\" AND user_group=\"" . addslashes($out[9]) . "\" AND user_id=\"" . $user_arr[0] . "\" AND period_id=\"" . $user_per . "\"";
      $sql_res = $db_con->Execute($SQL);
      check_sql_result($sql_res, $SQL, 1);
      $rows_days = $sql_res->GetRows();
      //end

      //   url_host    ,     
      $SQL = "SELECT count(*) FROM localhosts WHERE host LIKE \"%" . addslashes($url_host) . "%\"";
      $sql_res = $db_con->Execute($SQL);
      check_sql_result($sql_res, $SQL, 1);
      $rows = $sql_res->GetRows();
/*
echo $SQL . "\n";
echo $rows[0][0] . "\n";
//die;
*/
      if($rows[0][0] >= 1)
      {
        $bytes = 0;
        $cache = 0;
      } else
      {
        $bytes = $out[6];
        $cache = $out[6];
      }
      //end

      $record_count = $rows_days[0][0];

      if($record_count == 1) //   ,   UPDATE
      {
        $SQL = "UPDATE days SET bytes=bytes+\"" . $bytes . "\", cache=cache+\"" . $cache . "\" WHERE date=\"" . $str_date . "\" AND user_group=\"" . addslashes($out[9]) . "\" AND user_id=\"" . $user_arr[0] . "\" AND period_id=\"" . $user_per ."\"";
        $sql_res = $db_con->Execute($SQL);
        check_sql_result($sql_res, $SQL, 1);
      }

      if($record_count == 0) //  ,   INSERT
      {
        $SQL = "INSERT INTO days (date, user_id, user_group, bytes, cache, period_id) VALUES (\"" . $str_date . "\", \"" . $user_arr[0] ."\", \"" . addslashes($out[9]) . "\", \"". $bytes . "\", \"" . $cache . "\", \"" . $user_per . "\")";
        $sql_res = $db_con->Execute($SQL);
        check_sql_result($sql_res, $SQL, 1);
      }

      if($record_count >= 2) //-   1
      {
        write_log("Dublicate record: " . $out[0] . " " . $out[1] . ", user_id=" . $user_arr[0] . ", user_group=" . $out[9] . ", period_id=" . $user_per);
      }
    } else
    {
      if($cout == 1)
        echo "\tDENIED for: " . $out[9] . " (" . $out[4] . ")\n";
    }

    return $out;
  }

  function getmicrotime()
  {
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
  }

  function traf_period($db_con, $user_id, $tarif_id, $active_start, $active_finish)
  {
    //    
    $SQL =  "SELECT sum(bytes), period_id FROM days ";
    $SQL .= "WHERE user_id=\"" . $user_id . "\" AND date>=\"" . $active_start . "\" AND date<=\"" . $active_finish . "\" ";
    $SQL .= "GROUP BY period_id ORDER BY period_id";
    $sql_res_user = $db_con->GetAll($SQL);
    check_sql_result($sql_res_user, $SQL, 1);
    //end

    //  
    $SQL = "SELECT coef, period_id FROM tarif_period WHERE tarif_id=\"" . $tarif_id . "\" ORDER BY period_id, coef";
    $sql_res_period = $db_con->GetAll($SQL);
    check_sql_result($sql_res_period, $SQL, 1);
    //end

    $sum = 0;

    $rec_user   = count($sql_res_user);
    $rec_period = count($sql_res_period);

    for($i = 0; $i < $rec_user; $i++)
    {
      $cur_user_sum_bytes = $sql_res_user[$i][0];
      $cur_user_period    = $sql_res_user[$i][1];

      // .   tarif_period
      for($j = 0; $j < $rec_period; $j++)
      {
        if($cur_user_period == $sql_res_period[$j][1])
        {
          $cur_user_coef = $sql_res_period[$j][0];
          break;
        }
      }
      if($j == $rec_period) //  
        $cur_user_coef = 1;
      //end

      $sum += $cur_user_sum_bytes / $cur_user_coef; //  "-"  
    }

    return $sum;
  }

/*  $charset = "windows-1251";
  $unknown_name = "[]";
*/

?>
